/*
 * Renderer 9. The MIT License.
 * Copyright (c) 2022 rlkraft@pnw.edu
 * See LICENSE for details.
*/

import renderer.scene.*;
import renderer.scene.primitives.*;

/**
   Two dimensional letter P.
*/
public class P extends Model
{
   /**
      Two dimensional letter P.
   */
   public P()
   {
      super("P");

      addVertex(new Vertex(0.00, 0.00, 0.0),
                new Vertex(0.00, 1.00, 0.0),
                new Vertex(0.75, 1.00, 0.0),
                new Vertex(1.00, 0.8,  0.0),
                new Vertex(1.00, 0.6,  0.0),
                new Vertex(0.75, 0.4,  0.0),
                new Vertex(0.25, 0.4,  0.0),
                new Vertex(0.25, 0.0,  0.0),

                new Vertex(0.25, 0.8,  0.0),
                new Vertex(0.75, 0.8,  0.0),
                new Vertex(0.75, 0.6,  0.0),
                new Vertex(0.25, 0.6,  0.0));

      addPrimitive(new LineSegment(0, 1),
                   new LineSegment(1, 2),
                   new LineSegment(2, 3),
                   new LineSegment(3, 4),
                   new LineSegment(4, 5),
                   new LineSegment(5, 6),
                   new LineSegment(6, 7),
                   new LineSegment(7, 0),

                   new LineSegment(8,  9),
                   new LineSegment(9,  10),
                   new LineSegment(10, 11),
                   new LineSegment(11, 8));
   }


   public static void main(String[] args)
   {
      final double right  = 2.0;
      final double left   = -right;
      final double top    = right;
      final double bottom = -top;
      final Scene scene = new Scene("P",
                                 Camera.projOrtho(left, right, bottom, top));

      final renderer.framebuffer.FrameBuffer fb
                = new renderer.framebuffer.FrameBuffer(512, 512, java.awt.Color.black);

      final Model axes = new renderer.models_L.Axes2D(-2, +2, -2, +2, 8, 8);
      renderer.scene.util.ModelShading.setColor(axes, java.awt.Color.red);
      scene.addPosition(new Position(axes));

      final Model p = new P();
      renderer.scene.util.ModelShading.setColor(p, java.awt.Color.blue);
      scene.addPosition(new Position(p));

      renderer.pipeline.Pipeline.render(scene, fb);
      fb.dumpFB2File("P.ppm");
   }
}
