/*

*/

import renderer.scene.*;
import renderer.scene.primitives.*;

/**
   A two-dimensional wireframe model of the letter F.
*/
public class F extends Model
{
   /**
      The letter F.
   */
   public F()
   {
      super("F");

      // Create the vertices.
      addVertex(new Vertex(0.00, 0.0, 0.0),
                new Vertex(0.00, 1.0, 0.0),
                new Vertex(1.00, 1.0, 0.0),
                new Vertex(1.00, 0.8, 0.0),
                new Vertex(0.25, 0.8, 0.0),
                new Vertex(0.25, 0.6, 0.0),
                new Vertex(0.75, 0.6, 0.0),
                new Vertex(0.75, 0.4, 0.0),
                new Vertex(0.25, 0.4, 0.0),
                new Vertex(0.25, 0.0, 0.0));

      // Create the line segments.
      addPrimitive(new LineSegment(0, 1),
                   new LineSegment(1, 2),
                   new LineSegment(2, 3),
                   new LineSegment(3, 4),
                   new LineSegment(4, 5),
                   new LineSegment(5, 6),
                   new LineSegment(6, 7),
                   new LineSegment(7, 8),
                   new LineSegment(8, 9),
                   new LineSegment(9, 0));
   }
}
